package com.ricebook.rhllor.{{ name }};

{%- if jersey %}
import com.ricebook.rhllor.spring.boot.jersey.EnableJerseyConfiguration;
import com.ricebook.rhllor.spring.boot.jersey.exception.RhllorExceptionMapper;
import com.ricebook.rhllor.spring.boot.jersey.exception.RhllorValidationConfigurationContextResolver;
import com.ricebook.rhllor.spring.boot.jersey.exception.RhllorValidationExceptionMapper;
import com.ricebook.rhllor.spring.boot.jersey.filter.DynamicFilterFactory;
import com.ricebook.rhllor.spring.boot.jersey.provider.EnumParamConverterProvider;
import org.glassfish.jersey.media.multipart.MultiPartFeature;
import org.glassfish.jersey.server.spring.scope.RequestContextFilter;
import org.glassfish.jersey.fastjson.FastJsonFeature;
{%- endif %}

{%- if elastic_job %}
import com.ricebook.rhllor.spring.boot.starter.elasticjob.EnableElasticJobConfiguration;
{%- endif %}

{%- if kafka_consumer %}
import org.springframework.kafka.annotation.EnableKafka;
{%- endif %}

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;


/**
 * @author Rhllor Cli
 * @date {{ time }}
 */
{%- if jersey %}
@EnableJerseyConfiguration(
    scanPackage = "com.ricebook.rhllor.{{ name }}.resource"
)
{%- endif %}
{%- if elastic_job %}
@EnableElasticJobConfiguration(scanPackage = "com.ricebook.rhllor.{{ name }}.task")
{%- endif %}
{%- if kafka_consumer %}
@EnableKafka
{%- endif %}
@SpringBootApplication
public class Application {

  public static void main(String[] args) throws Exception {
    new SpringApplication(Application.class).run(args);
  }

}
